# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' PublicationItem Class
#'
#' A publication item, defined by a qualifier and a native accession, e.g. pubmed id.
#'
#' @field type 
#' @field accession 
#'
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
PublicationItem <- R6::R6Class(
  'PublicationItem',
  public = list(
    `type` = NULL,
    `accession` = NULL,
    initialize = function(`type`, `accession`){
      if (!missing(`type`)) {
        stopifnot(is.character(`type`), length(`type`) == 1)
        self$`type` <- `type`
      }
      if (!missing(`accession`)) {
        stopifnot(is.character(`accession`), length(`accession`) == 1)
        self$`accession` <- `accession`
      }
    },
    toJSON = function() {
      PublicationItemObject <- list()
      if (!is.null(self$`type`)) {
        PublicationItemObject[['type']] <- self$`type`
      }
      if (!is.null(self$`accession`)) {
        PublicationItemObject[['accession']] <- self$`accession`
      }

      PublicationItemObject
    },
    fromJSON = function(PublicationItemJson) {
      PublicationItemObject <- jsonlite::fromJSON(PublicationItemJson, simplifyVector = FALSE)
      if (!is.null(PublicationItemObject$`type`)) {
        self$`type` <- PublicationItemObject$`type`
      }
      if (!is.null(PublicationItemObject$`accession`)) {
        self$`accession` <- PublicationItemObject$`accession`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "type": %s,
           "accession": %s
        }',
        self$`type`,
        self$`accession`
      )
    },
    fromJSONString = function(PublicationItemJson) {
      PublicationItemObject <- jsonlite::fromJSON(PublicationItemJson, simplifyVector = FALSE)
      self$`type` <- PublicationItemObject$`type`
      self$`accession` <- PublicationItemObject$`accession`
    }
  )
)
