# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' SampleProcessing Class
#'
#' A list of parameters describing a sample processing, preparation or handling step similar to a biological or analytical methods report. The order of the sample_processing items should reflect the order these processing steps were performed in. If multiple parameters are given for a step these MUST be separated by a “|”. If derivatization was performed, it MUST be reported here as a general step, e.g. &#39;silylation&#39; and the actual derivatization agens MUST be specified in the Section 6.2.54 part.       
#'
#' @field id 
#' @field elementType 
#' @field sampleProcessing 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' MTD	sample_processing[1]	[MSIO, MSIO:0000107, metabolism quenching using precooled 60 percent methanol ammonium bicarbonate buffer,]
MTD	sample_processing[2]	[MSIO, MSIO:0000146, centrifugation,]
MTD	sample_processing[3]	[MSIO, MSIO:0000141, metabolite extraction,]
MTD	sample_processing[4]	[MSIO, MSIO:0000141, silylation,]

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
SampleProcessing <- R6::R6Class(
  'SampleProcessing',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `sampleProcessing` = NULL,
    initialize = function(`id`, `elementType`, `sampleProcessing`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`sampleProcessing`)) {
        stopifnot(is.list(`sampleProcessing`), length(`sampleProcessing`) != 0)
        lapply(`sampleProcessing`, function(x) stopifnot(R6::is.R6(x)))
        self$`sampleProcessing` <- `sampleProcessing`
      }
    },
    toJSON = function() {
      SampleProcessingObject <- list()
      if (!is.null(self$`id`)) {
        SampleProcessingObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        SampleProcessingObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`sampleProcessing`)) {
        SampleProcessingObject[['sampleProcessing']] <- lapply(self$`sampleProcessing`, function(x) x$toJSON())
      }

      SampleProcessingObject
    },
    fromJSON = function(SampleProcessingJson) {
      SampleProcessingObject <- jsonlite::fromJSON(SampleProcessingJson, simplifyVector = FALSE)
      if (!is.null(SampleProcessingObject$`id`)) {
        self$`id` <- SampleProcessingObject$`id`
      }
      if (!is.null(SampleProcessingObject$`elementType`)) {
        self$`elementType` <- SampleProcessingObject$`elementType`
      }
      if (!is.null(SampleProcessingObject$`sampleProcessing`)) {
        self$`sampleProcessing` <- lapply(SampleProcessingObject$`sampleProcessing`, function(x) {
          `sampleProcessingObject` <- Parameter$new()
          `sampleProcessingObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `sampleProcessingObject`
        })
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "sampleProcessing": [%s]
        }',
        self$`id`,
        self$`elementType`,
        lapply(self$`sampleProcessing`, function(x) paste(x$toJSON(), sep=","))
      )
    },
    fromJSONString = function(SampleProcessingJson) {
      SampleProcessingObject <- jsonlite::fromJSON(SampleProcessingJson, simplifyVector = FALSE)
      self$`id` <- SampleProcessingObject$`id`
      self$`elementType` <- SampleProcessingObject$`elementType`
      self$`sampleProcessing` <- lapply(SampleProcessingObject$`sampleProcessing`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
    }
  )
)
